<?php
// ----------------------------------
// import bookmarks into wiklink
// ----------------------------------

// ----------------------------------
// to parse HTML Export File
// ----------------------------------

function extractData($str) { 
	global $depth;
	$pos_h = strpos($str, "/H3>"); 		if ($pos_h === false) $pos_h=99999;
	$pos_a = strpos($str, "</A>");		if ($pos_h === false) $pos_a=99999;	
	$pos_first = min($pos_a, $pos_h);
		
	$sentence = substr($str,0, $pos_first+4);
	$depth += substr_count($sentence, "<DL>");
	$depth -= substr_count($sentence, "</DL>");
	
	$str = substr($str,$pos_first+4, strlen($str));
	if ($pos_h < $pos_a) extractH3($sentence);
			    	else extractA($sentence);			
	return $str;
}

function extractA($str) {  // get attributes of A TAG
	global $site, $id_site, $id_folder, $folder, $depth;
	$findMatches = preg_match_all("|href=\"?([^\"' >]+)?([^>]+)>?([^<]+)|i",$str,$matches);
	if($findMatches){
		for($i=0;$i<count($matches[0]);$i++){
		    $id_site++;			
			$site[$id_site]['url'] =  $matches[1][$i];
			$site[$id_site]['name'] = $matches[3][$i];
			$site[$id_site]['desc'] = "-";							
			if ($depth > $folder[$id_folder]['depth']) $site[$id_site]['parent'] = $id_folder; 
			   else if  ($depth == $folder[$id_folder]['depth']) $site[$id_site]['parent'] =  $folder[$id_folder]['parent']; 
			      else  $site[$id_site]['parent'] =  0; 
			$site[$id_site]['depth']  = $depth;						
		}
	}	
}

function extractH3($str) {  // get attributes of H3 TAG
	global $folder, $id_folder, $depth, $parent;
	$findMatches = preg_match_all("|<h3 ?([^>]+)>?([^<]+)|i",$str,$matches);
	if($findMatches){
		for($i=0;$i<count($matches[0]);$i++){	
		$id_folder++;
		$parent[$depth] = $id_folder;
		$folder[$id_folder]['name'] = $matches[2][$i];
		$folder[$id_folder]['desc'] = "-";
		$folder[$id_folder]['parent'] = $parent[$depth-1];
		$folder[$id_folder]['depth']  = $depth;				
		}
	}	
}

function parseHTML($url) {
		global $site, $id_site;
		global $folder, $id_folder;
		global $parent, $depth;

		$site  = array();
		$id_site = 0;
		
		$folder = array();     
		$id_folder = 0;
		$folder[0]['name'] = "root";
		$folder[0]['parent'] = 0;
		$folder[0]['depth']  = 0;
		
		$parent = array();  // store the parent for a given depth
		$depth = 0;
		$parent[0] = 0;
		
		if (!file_exists($url)) exit;		
		$source = implode("", file($url));
		while (strlen($source))  $source = extractData($source);		
}		


// ----------------------------------
// to display parsing result
// ----------------------------------

function displayExtractedData($folder, $site) { // only for debugging
	echo "<h1>folder</h1><hr>";
	for($i=0;$i<count($folder);$i++){ // list folder	
					echo "<br />".$i."-".$folder[$i]['name'];
					//echo " <i>".$folder[$i]['desc']."</i>";
					echo " - <font color=blue>".$folder[$i]['parent']."</font>";
					echo " <font color=green>".$folder[$folder[$i]['parent']]['name']."</font>";
					//echo " <font color=gray>".$folder[$i]['depth']."</font>";
	}
	echo "<h1>site</h1><hr>";
	for($i=1;$i<count($site);$i++){ // list site
				echo "<br />".$i."-".$site[$i]['name']."</a>";
				//echo $i."- <i>".$site[$i]['url']."</i>";
				echo " - <font color=blue>".$site[$i]['parent']."</font>";
				echo " - <font color=green>".$folder[$site[$i]['parent']]['name']."</font>";
				//echo $folder[$site[$i]['parent']]['name']."(<font color=gray>".$folder[$site[$i]['parent']]['depth']."</font>)";
				//echo "<font color=green>".$site[$i]['depth']."</font><br />";
	}
}

// ----------------------------------
// from bookmark array to SQL
// ----------------------------------
function getLastFolderID() {
	$query = "SELECT MAX(folder_id) AS foldermax FROM  wiklink_folder";
	$result = execQuery($query);
	$pt = nextLine($result);	
	return $pt->foldermax;	
}

function getLastSiteID() {
	$query = "SELECT MAX(site_id) AS sitemax FROM  wiklink_site";
	$result = execQuery($query);
	$pt = nextLine($result);	
	return $pt->sitemax;
}

function bookmarkDatatoSQL($folder, $site, $insertDirectoryID="0") {
	$site_p   = getLastSiteID();
	$folder_p = getLastFolderID();
	$noErrorOccurs = true;  // error flag
	$today = date('Y-m-d h:m:s');
	if (WIK_DEBUG) { displayExtractedData($folder, $site);}
	
	// importing folder	
	$folder[0]['id'] = $insertDirectoryID;	
	for($i=1;$i<count($folder);$i++){ 
		if ($noErrorOccurs) {
				if ($folder[$i]['parent'] ==0) $folder[$i]['parent'] = $insertDirectoryID;
							     else  $folder[$i]['parent'] += $folder_p;
				$folder[$i]['id'] = $folder_p+$i;
				$name   = addslashes($folder[$i]['name']);
				$desc   = addslashes($folder[$i]['desc']);
				$parent = addslashes($folder[$i]['parent']);
				$strSQL= "INSERT INTO wiklink_folder VALUES ('".$folder[$i]['id']."', '$name', '$today', '0', '$desc', '$parent');";  // should count items in directories  ?	
				if (WIK_DEBUG) echo "$strSQL \n";
				echo "\n...".$folder[$i]['name'];
			    $noErrorOccurs = execQuery($strSQL);				
		} 
	}
	echo "\n";
	
	// importing site	
	$user = getenv("REMOTE_ADDR");	
	for($i=1;$i<=count($site);$i++){ 
		if ($noErrorOccurs) {
			$name   = addslashes($site[$i]['name']);
			$desc   = addslashes($site[$i]['desc']);
			$url    = addslashes($site[$i]['url']);
			$parent = addslashes($folder[$site[$i]['parent']]['id']);
			$strSQL= "INSERT INTO wiklink_site VALUES ('".($site_p+$i)."', '$name', '$today', '$parent',  '$desc', '$url', '$user', '0');"; 	
			if (WIK_DEBUG) echo "$strSQL \n";
			echo "\n...".$site[$i]['name'];
		    $noErrorOccurs = execQuery($strSQL);
		}
	}
	
	
	echo "\n\n";
	return $noErrorOccurs;
}

				
?>
